/****************************************************************/
/*			FCE Ultra				*/
/*								*/
/*	This file contains code to interface to the standard    */
/*	FCE Ultra configuration file saving/loading code.	*/
/*								*/
/****************************************************************/
#include "../common/config.h"

#define AC(x)   {#x,&##x##,sizeof(##x##)}
#define NAC(w,x) {#w,&##x##,sizeof(##x##)} 

#define ACA(x)   {#x,##x##,sizeof(##x##)}
#define NACA(w,x) {#w,##x##,sizeof(##x##)}

#define ACS(x)  {#x,&##x##,0}
#define NACS(w,x)  {#w,&##x##,0}

//// cheats, misc, nonvol, states, snaps, base
//static char *DOvers[6]={0,0,0,0,0,0};


#define CONFIGITEMS 52
static CFGSTRUCT fceuconfig[CONFIGITEMS]={

        AC(ntsccol),AC(ntsctint),AC(ntschue),

	NAC("palyo",palyo),
	NAC("genie",genie),
	NAC("fs",fullscreen),
	NAC("vgamode",vmod),
	NAC("sound",soundo),

        ACS(gfsdir),

        NACS("odcheats",DOvers[0]),
        NACS("odmisc",DOvers[1]),
        NACS("odnonvol",DOvers[2]),
        NACS("odstates",DOvers[3]),
        NACS("odsnaps",DOvers[4]),
        NACS("odbase",DOvers[5]),

	NAC("winsizemul",winsizemul),

	AC(soundrate),
        AC(soundbuftime),
	AC(soundoptions),
        AC(soundvolume),

	NAC("eoptions",eoptions),
        NACA("cpalette",cpalette),

        ACA(joy),
	ACA(joyA),ACA(joyB),ACA(joySelect),ACA(joyStart),

        AC(joyOptions),
        ACA(joyUp),ACA(joyDown),ACA(joyLeft),ACA(joyRight),

	NACA("InputType",InputType),
	NAC("keyben",keybEnable),

	NACA("keybm0",keyBMap[0]),
	NACA("keybm1",keyBMap[1]),
	NACA("keybm2",keyBMap[2]),
	NACA("keybm3",keyBMap[3]),
	NACA("ppasc0",powerpadsc[0]),
	NACA("ppasc1",powerpadsc[1]),

	NAC("ppaside",powerpadside),
	NAC("vmcx",vmodes[0].x),
	NAC("vmcy",vmodes[0].y),
	NAC("vmcb",vmodes[0].bpp),
	NAC("vmcf",vmodes[0].flags),
	NAC("vmcxs",vmodes[0].xscale),
	NAC("vmcys",vmodes[0].yscale),

	AC(srendline),
	AC(erendline),
	AC(JoyMulti),
	AC(winsync),
	AC(fssync)
};

static void SaveConfig(char *filename)
{
        DriverInterface(DES_GETNTSCTINT,&ntsctint);
        DriverInterface(DES_GETNTSCHUE,&ntschue);
        SaveFCEUConfig(filename,fceuconfig,CONFIGITEMS);
}

static void LoadConfig(char *filename)
{
        DriverInterface(DES_GETNTSCTINT,&ntsctint);
        DriverInterface(DES_GETNTSCHUE,&ntschue);
        LoadFCEUConfig(filename,fceuconfig,CONFIGITEMS);
	DriverInterface(DES_NTSCCOL,&ntsccol);
        DriverInterface(DES_SETNTSCTINT,&ntsctint);
        DriverInterface(DES_SETNTSCHUE,&ntschue);

	palyo&=1;
	FCEUI_SetVidSystem(palyo);
	genie&=1;
	FCEUI_SetGameGenie(genie);
	fullscreen&=1;
	soundo&=1;
        FCEUI_SetSoundVolume(soundvolume);
}

