#include "common.h"
#include <dinput.h>

#include "input.h"
#include "keyboard.h"
#include "joystick.h"


int JoyMulti=0;
int InputType[2]={DII_SETCONTROL_GAMEPAD,DII_SETCONTROL_GAMEPAD};


static uint32 powerpadbuf[2];

LPDIRECTINPUT7 lpDI;


static uint32 JSreturn;
static uint32 mousedata[3];


static void ConfigGamePad(HWND hParent, int port);

int InitDInput(void)
{
 HRESULT ddrval;

 ddrval=DirectInputCreateEx(fceu_hInstance,DIRECTINPUT_VERSION,&IID_IDirectInput7,(LPVOID *)&lpDI,0);
 if(ddrval!=DI_OK)
 {
  FCEUD_PrintError("DirectInput: Error creating DirectInput object.");
  return 0;
 }
 return 1;
}

static int screenmode=0;
void InputScreenChanged(int fs)
{
 if(InputType[0]==DII_SETCONTROL_ZAPPER)
  DriverInputInterface(DII_SETCONTROLATTRIB,0,fs,0);
 if(InputType[1]==DII_SETCONTROL_ZAPPER)
  DriverInputInterface(DII_SETCONTROLATTRIB,1,fs,0);
 screenmode=fs;
}


void CreateInputStuff(void)
{ 
   void *InputDPtr=0;
   int x;
   
   KeyboardInitialize();
   InitJoysticks();

   DriverInputInterface(DII_SETMULTI,0,JoyMulti,0);

   for(x=0;x<2;x++)
   {
    int TAttrib=0;
    switch(InputType[x])
    {
     case DII_SETCONTROL_GAMEPAD:InputDPtr=((uint8 *)&JSreturn)+(x<<1);
				 break;
     case DII_SETCONTROL_POWERPAD:InputDPtr=&powerpadbuf[x];break;
     case DII_SETCONTROL_ZAPPER:InputDPtr=mousedata;
                                TAttrib=screenmode;
                                break;
    }
    DriverInputInterface(DII_SETCONTROL,x,InputType[x],InputDPtr);
    DriverInputInterface(DII_SETCONTROLATTRIB,x,TAttrib,0);
   }   
}

void DestroyInput(void)
{
   KillJoysticks();
   KeyboardClose();
}

void FCEUD_UpdateInput(void)
{
  int x;
  uint32 JS;
  int t=0;

  KeyboardUpdate();

  for(x=0;x<2;x++)
   switch(InputType[x])
   {
    case DII_SETCONTROL_GAMEPAD:t|=1;break;
    case DII_SETCONTROL_ZAPPER:t|=2;break;
    case DII_SETCONTROL_POWERPAD:powerpadbuf[x]=UpdatePPadData(x);break;
   }
  if(t&1)
  {
   JS=KeyboardDodo();
   if(joy[0]|joy[1]|joy[2]|joy[3])
    JS|=(uint32)GetJSOr();
   JSreturn=(JS&0xFF000000)|(JS&0xFF)|((JS&0xFF0000)>>8)|((JS&0xFF00)<<8);   
  }
  if(t&2)  
   GetMouseData(&mousedata[0], &mousedata[1], &mousedata[2]);
}


BOOL CALLBACK InputConCallB(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static const void (*boopar[4])(HWND hParent, int port)={0,(void*)ConfigGamePad,0,(void *)ConfigKeyboardiePowerpad};
  int x;
  
  switch(uMsg) {
   case WM_INITDIALOG:                
                for(x=0;x<2;x++)
                {
                 SendDlgItemMessage(hwndDlg,104+x,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");
                 SendDlgItemMessage(hwndDlg,104+x,CB_ADDSTRING,0,(LPARAM)(LPSTR)"Gamepad");
                 SendDlgItemMessage(hwndDlg,104+x,CB_ADDSTRING,0,(LPARAM)(LPSTR)"Zapper");
                 SendDlgItemMessage(hwndDlg,104+x,CB_ADDSTRING,0,(LPARAM)(LPSTR)"Power Pad");
                 SendDlgItemMessage(hwndDlg,104+x,CB_SETCURSEL,InputType[x],(LPARAM)(LPSTR)0);
                }
                break;
   case WM_CLOSE:
   case WM_QUIT: goto gornk;
   case WM_COMMAND:
                if(!(wParam>>16))
                switch(wParam&0xFFFF)
                {
                 case 107:
                 case 106:
                  {
                   int t=(wParam&0xFFFF)-106;
                   x=SendDlgItemMessage(hwndDlg,104+t,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
                   if(boopar[x])
                    boopar[x](hwndDlg,t);
                  }
                  break;
                 case 1:
                        gornk:
                        InputType[0]=SendDlgItemMessage(hwndDlg,104,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);;
                        InputType[1]=SendDlgItemMessage(hwndDlg,105,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);                        
                        EndDialog(hwndDlg,0);
                        break;
               }
              }
  return 0;
}

void ConfigInput(HWND hParent)
{
  DialogBox(fceu_hInstance,"INPUTCONFIG",hParent,InputConCallB);
  CreateInputStuff();
}


static int porttemp;

BOOL CALLBACK GPConCallB(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch(uMsg) {
   case WM_INITDIALOG:                
                if(JoyMulti)
                 CheckDlgButton(hwndDlg,200,BST_CHECKED);
                break;
   case WM_CLOSE:
   case WM_QUIT: goto gornk;
   case WM_COMMAND:
                if(!(wParam>>16))
                switch(wParam&0xFFFF)
                {
                 case 107:ConfigJoystickies(hwndDlg, porttemp);break;
                 case 106:ConfigKeyboardie(hwndDlg, porttemp);break;
                 case 1:
                        gornk:
                        JoyMulti=0;
                        if(IsDlgButtonChecked(hwndDlg,200)==BST_CHECKED)
                         JoyMulti=1;
                        EndDialog(hwndDlg,0);
                        break;
               }
              }
  return 0;
}

static void ConfigGamePad(HWND hParent, int port)
{
  porttemp=port;
  DialogBox(fceu_hInstance,"GAMEPADCONFIG",hParent,GPConCallB);
}


